<template>
  <v-container>
    <v-row class="text-center">
      <v-col cols="12">
        <v-data-table
          :headers="headers"
          :items="items"
          :items-per-page="5"
          :loading="loading"
          class="elevation-1"
        >
          <!-- header -->
          <template v-slot:top>
            <v-toolbar flat>
              <v-toolbar-title>Funcionários</v-toolbar-title>
              <v-divider class="mx-4" inset vertical />
              <v-spacer />
              <v-btn
                color="primary"
                dark
                class="mb-2"
                :disabled="loading"
                @click="modalFormConfirm(true, null)"
              >
                Novo
              </v-btn>
            </v-toolbar>
          </template>
          <!-- actions -->
          <template v-slot:[`item.actions`]="{ item }">
            <v-btn
              icon
              :disabled="loading"
              @click="modalFormConfirm(true, item)"
            >
              <v-icon>mdi-pencil</v-icon>
            </v-btn>
            <v-btn
              icon
              :disabled="loading"
              @click="modalDeleteConfirm(true, item)"
            >
              <v-icon>mdi-delete</v-icon>
            </v-btn>
          </template>
        </v-data-table>
      </v-col>
    </v-row>

    <!-- dialog:new:edit -->
    <form-employee
      v-model="formConfirm"
      :item="editData"
      @new-form="submit($event)"
      @edit-form="update($event)"
    />

    <!-- dialog:delete -->
    <v-dialog v-model="deleteConfirm" max-width="500px">
      <v-card>
        <v-card-title class="text-h5">Deseja excluir este item?</v-card-title>
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="blue darken-1"
            text
            :disabled="loading"
            @click="modalDeleteConfirm(false, null)"
          >
            Cancelar
          </v-btn>
          <v-btn
            color="blue darken-1"
            text
            :disabled="loading"
            @click="destroy(deleteData)"
          >
            OK
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
export default {
  components: {
    FormEmployee: () => import('@/components/FormEmployee.vue'),
  },

  data() {
    return {
      loading: false,
      items: [],

      headers: [
        {
          text: 'Funcionário',
          align: 'start',
          value: '_full_name',
        },
        { text: 'Cor', value: 'color' },
        { text: 'Ações', sortable: false, value: 'actions' },
      ],

      formConfirm: false,
      editData: null,

      deleteConfirm: false,
      deleteData: null,
    }
  },

  async created() {
    this.loading = true

    try {
      const { data } = await this.$axios.get('employees')
      this.items = data.data
    } catch (error) {
      console.error(error)
    }

    this.loading = false
  },

  methods: {
    async submit(form) {
      this.loading = true

      try {
        const { data } = await this.$axios.post('employees', form)

        this.items.push(data.data)
        this.modalFormConfirm(false, null)
      } catch (error) {
        console.error(error)
      }

      this.loading = false
    },

    async update(form) {
      this.loading = true

      try {
        const { data } = await this.$axios.put(
          `employees/${this.editData._id}`,
          form,
        )

        this.$set(this.items, this.items.indexOf(this.editData), data.data)
        this.modalFormConfirm(false, null)
      } catch (error) {
        console.error(error)
      }

      this.loading = false
    },

    async destroy(item) {
      if (this.deleteData) {
        this.loading = true

        try {
          await this.$axios.delete(`employees/${item._id}`)

          this.$delete(this.items, this.items.indexOf(item))
        } catch (error) {
          console.error(error)
        }

        this.loading = false
        this.modalDeleteConfirm(false, null)
      } else {
        this.deleteConfirm = false
      }
    },

    modalFormConfirm(bool, item) {
      this.formConfirm = bool
      this.editData = item
    },

    modalDeleteConfirm(bool, item) {
      this.deleteConfirm = bool
      this.deleteData = item
    },
  },
}
</script>
